#!/bin/sh
# gen-init.sh -- Create a file initializing all modules.
# Copyright (C) 2004 Wolfgang Jhrling
#
# Permission to use, copy, modify, and/or distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

modules=`cat ${1:-modules}`
rmodules=`tac ${1:-modules}`
exec 3>init.c
out () { echo >&3 "$@"; }

out '/* Generated by gen-init.sh */'

for m in $modules
do
  out "#include \"$m.h\""
done

out '
int global_argc;
char **global_argv;

int
main (int argc, char **argv)
{
  global_argc = argc;
  global_argv = argv;
'

for m in $modules
do
  out "  setup_`echo $m | sed -e 's!^.*/\([^/]\+\)$!\1!'` ();"
done

for m in $modules
do
  out "  init_`echo $m | sed -e 's!^.*/\([^/]\+\)$!\1!'` ();"
done

for m in $rmodules
do
  out "  finish_`echo $m | sed -e 's!^.*/\([^/]\+\)$!\1!'` ();"
done

out '
  return 0;
}'
