/* num.h -- Numbers interface.
 * Copyright (C) 2014 Wolfgang Jaehrling
 *
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#ifndef PWG_NUM_H
#define PWG_NUM_H

#include <stdint.h>

#include "pwg.h"

pwg_t num_float (double d);
double num_unfloat (pwg_t f);

pwg_t pwg_num_float_p (pwg_t o);
pwg_t pwg_num_sint_p (pwg_t o);
pwg_t pwg_num_sint_to_float (pwg_t x);
pwg_t pwg_num_float_to_sint (pwg_t x);

pwg_t pwg_num_mod (pwg_t a, pwg_t b);
pwg_t pwg_num_bit_and (pwg_t a, pwg_t b);
pwg_t pwg_num_bit_or (pwg_t a, pwg_t b);
pwg_t pwg_num_bit_xor (pwg_t a, pwg_t b);
pwg_t pwg_num_bit_not (pwg_t x);

pwg_t pwg_num_equal_p (pwg_t a, pwg_t b);
pwg_t pwg_num_nequal_p (pwg_t a, pwg_t b);
pwg_t pwg_num_geq_p (pwg_t a, pwg_t b);
pwg_t pwg_num_leq_p (pwg_t a, pwg_t b);
pwg_t pwg_num_gt_p (pwg_t a, pwg_t b);
pwg_t pwg_num_lt_p (pwg_t a, pwg_t b);

pwg_t pwg_num_plus (pwg_t a, pwg_t b);
pwg_t pwg_num_minus (pwg_t a, pwg_t b);
pwg_t pwg_num_mul (pwg_t a, pwg_t b);
pwg_t pwg_num_div (pwg_t a, pwg_t b);

void setup_num (void);
void init_num (void);
void finish_num (void);

#endif /* PWG_NUM_H */
